"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var twins_1 = require("../twins");
var defaultRequest = {
    method: 'GET',
    body: {},
    cookies: {},
    query: {},
    get: function () { return ''; },
};
function run(req) {
    return __awaiter(this, void 0, void 0, function () {
        var set, status, middleware;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    set = jest.fn();
                    status = jest.fn();
                    return [4 /*yield*/, (0, twins_1.twinsMiddleware)('./test_twins')];
                case 1:
                    middleware = _a.sent();
                    return [2 /*return*/, new Promise(function (resolve, reject) {
                            var res = {
                                set: set,
                                status: status,
                                send: function (reply) { return resolve({ reply: reply, set: set, status: status }); },
                            };
                            middleware(req, res, function (err) { return reject(err || 'empty'); });
                        })];
            }
        });
    });
}
it('Finds "can" with story set in get parameter', function () { return __awaiter(void 0, void 0, void 0, function () {
    var _a, reply, set, status;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, run(__assign(__assign({}, defaultRequest), { query: {
                        api_twin: 'story1:user_exists',
                        seriesId: '8',
                        mode: '2',
                    }, url: '/api/forms/v1/form' }))];
            case 1:
                _a = _b.sent(), reply = _a.reply, set = _a.set, status = _a.status;
                expect(reply).toEqual({
                    key1: 'value1',
                    key2: 'value2'
                });
                expect(set).toHaveBeenCalledWith('Content-Type', 'application/json');
                expect(status).toHaveBeenCalledWith(200);
                return [2 /*return*/];
        }
    });
}); });
it('Finds "can" with story set in the header', function () { return __awaiter(void 0, void 0, void 0, function () {
    var _a, reply, set, status;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, run(__assign(__assign({}, defaultRequest), { query: {
                        seriesId: '8',
                        mode: '2',
                    }, get: function (hdr) { return hdr === 'x-api-twin'
                        ? 'story1:user_exists'
                        : ''; }, url: '/api/forms/v1/form' }))];
            case 1:
                _a = _b.sent(), reply = _a.reply, set = _a.set, status = _a.status;
                expect(reply).toEqual({
                    key1: 'value1',
                    key2: 'value2'
                });
                expect(set).toHaveBeenCalledWith('Content-Type', 'application/json');
                expect(status).toHaveBeenCalledWith(200);
                return [2 /*return*/];
        }
    });
}); });
it('Finds with story set in the cookie', function () { return __awaiter(void 0, void 0, void 0, function () {
    var _a, reply, set, status;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, run(__assign(__assign({}, defaultRequest), { query: {
                        seriesId: '8',
                        mode: '2',
                    }, cookies: {
                        api_twin: 'story1:user_exists',
                    }, url: '/api/forms/v1/form' }))];
            case 1:
                _a = _b.sent(), reply = _a.reply, set = _a.set, status = _a.status;
                expect(reply).toEqual({
                    key1: 'value1',
                    key2: 'value2'
                });
                expect(set).toHaveBeenCalledWith('Content-Type', 'application/json');
                expect(status).toHaveBeenCalledWith(200);
                return [2 /*return*/];
        }
    });
}); });
it('Calls next() if not found', function () {
    return expect(run(__assign(__assign({}, defaultRequest), { query: {
            seriesId: '8',
            mode: '3',
        }, cookies: {
            api_twin: 'story1:user_exists',
        }, url: '/api/forms/v1/form' }))).rejects.toMatch('empty');
});
//# sourceMappingURL=middleware.spec.js.map